<template>
  <div class="game-board">
    <board :state="state" />
  </div>
  <div
    class="player"
    v-for="player in state.players"
    :key="player.id"
    :style="
      getPlayerTransform(sortedPlayers.findIndex((p) => p.id === player.id))
    "
  >
    <gs6-player-box :playerid="player.id" :active="isActivePlayer(player.id)">
      <span slot="after-name">
        <player-icon :playerId="player.id" :players="state.players" />
      </span>
      <button
        class="secondary"
        v-if="
          !emptyRunners &&
          player.id === playerId &&
          state.phase.name === 'rolling' &&
          state.phase.player === playerId
        "
        v-on:click="stop"
      >
        Stop
      </button>
      <button
        class="primary"
        v-if="
          player.id === playerId &&
          state.phase.name === 'rolling' &&
          state.phase.player === playerId
        "
        v-on:click="roll"
      >
        <span v-if="emptyRunners">Roll dice</span>
        <span v-else>Keep going</span>
      </button>
      <ul
        class="player-dice"
        v-if="
          state.phase.name === 'pairing' && state.phase.player === player.id
        "
      >
        <li v-for="(die, idx) in state.phase.dice" :key="idx">
          <label
            class="selectable-die"
            v-if="player.id === playerId"
            :for="`player-die-${idx}`"
          >
            <gs6-die :value="die" />
            <input
              type="checkbox"
              :value="idx"
              v-model="selectedDice"
              :id="`player-die-${idx}`"
            />
          </label>
          <gs6-die v-else :value="die" />
        </li>
      </ul>
      <button
        class="primary"
        v-if="
          state.phase.name === 'pairing' &&
          state.phase.player === playerId &&
          player.id === playerId
        "
        :disabled="selectedDice.length !== 2"
        v-on:click="pair"
      >
        Pair dice
      </button>
    </gs6-player-box>
  </div>
  <div
    v-if="state.phase.name === 'complete'"
    class="panel border shadow summary"
  >
    <gs6-user :userid="state.phase.winner" /> wins!
  </div>
</template>

<script lang="ts">
import Board from "./Board.vue";
import { defineComponent, PropType } from "vue";
import { withUserFirst, isEmptyObject } from "../util";
import PlayerIcon from "./PlayerIcon.vue";

export default defineComponent({
  name: "game",
  components: { Board, PlayerIcon },
  data(vm) {
    return {
      state: vm.initialState,
      settings: vm.initialSettings,
      playerId: vm.initialPlayerId,
      selectedDice: [],
    };
  },
  methods: {
    getPlayerTransform(idx: number): string {
      const angleStep = (2 * Math.PI) / this.playerCount;
      const startAngle = -(Math.PI / 2);

      const angle = startAngle + idx * angleStep;
      const xUnit = Math.cos(angle);
      const yUnit = Math.sin(angle);

      const x = xUnit * -18;
      const y = yUnit * -20;

      let initialTranslate = "translate(-50%, -50%)";
      if (x > 0.5) {
        initialTranslate = "translate(0, -50%)"; // players on the right grow toward the right
      } else if (x < -0.5) {
        initialTranslate = "translate(-100%, -50%)"; // players on the left grow toward the left
      }

      return `
        transform: ${initialTranslate}
          translate(${x.toFixed(2)}rem, ${y.toFixed(2)}rem);
        transition: transform 0.5s;
        `;
    },
    roll(): void {
      this.onAction({ name: "roll" });
    },
    pair(): void {
      this.onAction({ name: "pair", dice: this.selectedDice });
      this.selectedDice = [];
    },
    stop(): void {
      this.onAction({ name: "stop" });
    },
    isActivePlayer(playerId: PlayerId): boolean {
      return this.state?.phase.player === playerId;
    },
  },
  computed: {
    playerCount(): number {
      return this.state?.players.length ?? 0;
    },
    sortedPlayers(): Player[] {
      return withUserFirst(this.state?.players ?? [], this.playerId);
    },
    emptyRunners(): boolean {
      return isEmptyObject(this.state?.runners ?? {});
    },
  },
  props: {
    initialState: { type: Object as PropType<GameState>, required: true },
    initialSettings: { type: Object as PropType<GameSettings>, required: true },
    initialPlayerId: { type: Number, required: false },
    onAction: {
      type: Function as PropType<(action: Action) => void>,
      required: true,
    },
  },
});
</script>

<style lang="scss" scoped>
.game-board {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}
.player {
  position: absolute;
  top: 50%;
  left: 50%;

  button.primary {
    position: absolute;
    bottom: 0;
    right: 0;
    transform: translate(100%, -25%) translateX(1rem);
  }
  button.secondary {
    position: absolute;
    bottom: 0;
    left: 0;
    transform: translate(-100%, -25%) translateX(-1rem);
  }

  .player-dice {
    margin: 0;
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 100%) scale(1.5) translateY(16.67%);

    display: flex;

    > li {
      margin-left: 0.33em;
      margin-right: 0.33em;
    }
  }
}

.selectable-die {
  cursor: pointer;
}
.selectable-die > input {
  cursor: pointer;
}

.summary {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}
</style>
